vif = V -- target vessel interface
if vif == nil then
   vif = vessel.get_focusinterface()
end

--target = vessel.get_interface('GL-01')
target = vessel.get_interface('ISS')

gravref = vif:get_gravityref()

mu = GGRAV*oapi.get_mass(gravref)

function orbit_tgt(v,t,off,bt,elev)
	local dx = off.x*304.8
	local dz = off.z*304.8
	t=t*60
	local simt = oapi.get_simtime()
	local IAR,IAV = sv_from_coe (v)
	local IPR,IPV = sv_from_coe (target)
	local simt2 = oapi.get_simtime()
	local svtime=(simt+simt2)/2
	if elev~=nil then
	elev=elev*RAD
	local bt2=bt
	bt=find_elev(v,t,bt,elev)
	term.out('Old burntime:')
	term.out(bt2)
	term.out('New burntime:')
	term.out(bt)
	end
	local timetoburn=bt-svtime
	local IAR_TI,IAV_TI = rv_from_r0v0(IAR,IAV,timetoburn)
	local IPR_REND,IPV_REND = rv_from_r0v0(IPR,IPV,timetoburn+t)
	--term.out(IPR_REND)
	local IPR_REND_off=REND_offset(IPR_REND,IPV_REND,dx,dz)
	--term.out(IPR_REND_off)
	local V_i = lambert(IAR_TI,IPR_REND_off,t)
	local V_m = vec.sub(V_i,IAV_TI)
	local k = vec.unit(IAV_TI)
	local i = vec.unit(vec.crossp(IAV_TI,vec.mul(-1,IAR_TI)))
	local j = vec.unit(vec.crossp(i,IAV_TI))
	local QXx = {m11=i.x, m12=i.y, m13=i.z, m21=j.x, m22=j.y, m23=j.z, m31=k.x, m32=k.y, m33=k.z}
	local V_mE = mat.mul(QXx,V_m)
	term.out('dv vector:')
	term.out(V_mE)
	term.out('Total delta-v in fps:')
	term.out(vec.length(V_mE)/0.3048)
	return V_mE
end

function burn (v,dv,t)
	local bt = maneuver_time(v,dv)
	while oapi.get_simtime()<t-300-bt/2 do
		proc.skip()
	end
	term.out('5 minutes to burn')
	while oapi.get_simtime()<t-60-bt/2 do
		proc.skip()
	end
	term.out('1 minute to burn')
	while oapi.get_simtime()<t-30-bt/2 do
		proc.skip()
	end
	dv_maneuver(v,dv,t)
end

function oms_burn (v,dv,t)
	local bt = burntime_oms(v,math.abs(vec.length(dv)))
	local yaw = math.atan2(dv.x,dv.z)
	local pit = math.atan2(-dv.y,dv.z)
	term.out('Required Yaw:')
	term.out(yaw*DEG)
	term.out('Required Pitch:')
	term.out(pit*DEG)
	while oapi.get_simtime()<t-300-bt/2 do
		proc.skip()
	end
	term.out('5 minutes to burn')
	while oapi.get_simtime()<t-60-bt/2 do
		proc.skip()
	end
	term.out('1 minute to burn')
	while oapi.get_simtime()<t-bt/2 do
		proc.skip()
	end
	v:set_thrustergrouplevel (THGROUP.MAIN, 1)
	proc.wait_simdt(bt)
	v:set_thrustergrouplevel (THGROUP.MAIN, 0)
	attoff(v)
end

function autopilot()
term.out('Autopilot activated')
t=57.7
t_TI=oapi.get_simtime()+apt(vif)
t_NCC=t_TI-57*60-42
offs=vec.set(-48.6,0,1.2)
dv=orbit_tgt(vif,t,offs,t_NCC)
term.out('The NCC-burn will be at:')
term.out(t_NCC)
while oapi.get_simtime()<t_NCC-300 do
proc.skip()
end
dv=orbit_tgt(vif,t,offs,t_NCC)
term.out('Activate Attitude MFD and maneuver to')
term.out('a prograde direction (0,0,0)')
term.out('Deactivate Attitude Hold shortly before the burn')
burn(vif,dv,t_NCC)
term.out('Activate Attitude Hold again')
t=76.9
offs.x=-0.9
offs.z=1.8
dv=orbit_tgt(vif,t,offs,t_TI)
term.out('The TI-burn will be at:')
term.out(t_TI)
while oapi.get_simtime()<t_TI-300 do
proc.skip()
end
dv=orbit_tgt(vif,t,offs,t_TI)
term.out('Maneuver to the displayed direction')
term.out('You can leave the Attitude Hold on')
term.out('during the OMS burn')
oms_burn(vif,dv,t_TI)
t_MC1=t_TI+20*60
t=56.9
dv=orbit_tgt(vif,t,offs,t_MC1)
term.out('The MC1-burn will be at:')
term.out(t_MC1)
while oapi.get_simtime()<t_MC1-300 do
proc.skip()
end
dv=orbit_tgt(vif,t,offs,t_MC1)
term.out('Activate Attitude MFD and maneuver to')
term.out('a prograde direction (0,0,0)')
term.out('Deactivate Attitude Hold shortly before the burn')
burn(vif,dv,t_MC1)
term.out('Activate Attitude Hold again')
t_MC2=t_TI+49*60+54
t=27
elev=29.07
t_MC2=find_elev(vif,t,t_MC2,elev)
dv=orbit_tgt(vif,t,offs,t_MC2,elev)
term.out('The MC2-burn will be at:')
term.out(t_MC2)
while oapi.get_simtime()<t_MC2-300 do
proc.skip()
end
term.out('Activate Attitude MFD and maneuver to')
term.out('a prograde direction (0,0,0)')
term.out('Deactivate Attitude Hold shortly before the burn')
burn(vif,dv,t_MC2)
term.out('Activate Attitude Hold again')
t_MC3=t_MC2+17*60
t=10
dv=orbit_tgt(vif,t,offs,t_MC3)
term.out('The MC3-burn will be at:')
term.out(t_MC3)
while oapi.get_simtime()<t_MC3-300 do
proc.skip()
end
dv=orbit_tgt(vif,t,offs,t_MC3)
term.out('Activate Attitude MFD and maneuver to')
term.out('a prograde direction (0,0,0)')
term.out('Deactivate Attitude Hold shortly before the burn')
burn(vif,dv,t_MC3)
term.out('Activate Attitude Hold again')
t_MC4=t_MC2+27*60
t=13
offs.x=0
offs.z=0.6
dv=orbit_tgt(vif,t,offs,t_MC4)
term.out('The MC4-burn will be at:')
term.out(t_MC4)
while oapi.get_simtime()<t_MC4-300 do
proc.skip()
end
dv=orbit_tgt(vif,t,offs,t_MC4)
term.out('Activate Attitude MFD and maneuver to')
term.out('a prograde direction (0,0,0)')
term.out('Deactivate Attitude Hold shortly before the burn')
burn(vif,dv,t_MC4)
end

function maneuver_time(v,dv)
	xburnt = burntime_att(v,math.abs(dv.x))
	yburnt = burntime_att(v,math.abs(dv.y))
	zburnt = burntime_att_for(v,math.abs(dv.z)) --_for
	return xburnt+yburnt+zburnt
end

function REND_offset(R,V,dx,dz)
local v_t=vec.length(V)
local dt = dx/v_t
local R_off,V_off = rv_from_r0v0(R,V,dt)
local r_t=vec.length(R_off)
local fac = (r_t-dz)/r_t
R_off.x=fac*R_off.x
R_off.y=fac*R_off.y
R_off.z=fac*R_off.z
return R_off
end

function dv_maneuver(v,dv,t_ig)
	xburnt = burntime_att(v,math.abs(dv.x))
	yburnt = burntime_att(v,math.abs(dv.y))
	zburnt = burntime_att_for(v,math.abs(dv.z)) --_for
	--term.out(xburnt)
	--term.out(yburnt)
	--term.out(zburnt)
	local xburnprog = proc.bg(xburn,v,xburnt,t_ig,dv.x)
	local yburnprog = proc.bg(yburn,v,yburnt,t_ig,dv.y)
	local zburnprog = proc.bg(zburn,v,zburnt,t_ig,dv.z)
	proc.wait_simtime(t_ig+xburnt/2+yburnt/2+zburnt/2)
	proc.kill(xburnprog)
	proc.kill(yburnprog)
	proc.kill(zburnprog)
	attoff(v)
end

function xburn(v,bt,t_ig,dv)
	while oapi.get_simtime()<t_ig-bt/2 do
	proc.skip()
	end
	if dv > 0 then
	v:set_thrustergrouplevel(THGROUP.ATT_LEFT,1)
	proc.wait_simdt(bt)
	v:set_thrustergrouplevel(THGROUP.ATT_LEFT,0)
	elseif dv < 0 then
	v:set_thrustergrouplevel(THGROUP.ATT_RIGHT,1)
	proc.wait_simdt(bt)
	v:set_thrustergrouplevel(THGROUP.ATT_RIGHT,0)
	end
end

function yburn(v,bt,t_ig,dv)
	while oapi.get_simtime()<t_ig-bt/2 do
	proc.skip()
	end
	if dv > 0 then
	v:set_thrustergrouplevel(THGROUP.ATT_DOWN,1)
	proc.wait_simdt(bt)
	v:set_thrustergrouplevel(THGROUP.ATT_DOWN,0)
	elseif dv < 0 then
	v:set_thrustergrouplevel(THGROUP.ATT_UP,1)
	proc.wait_simdt(bt)
	v:set_thrustergrouplevel(THGROUP.ATT_UP,0)
	end
end

function zburn(v,bt,t_ig,dv)
	while oapi.get_simtime()<t_ig-bt/2 do
	proc.skip()
	end
	if dv > 0 then
	lin_forward(v,bt)
	elseif dv < 0 then
	v:set_thrustergrouplevel(THGROUP.ATT_BACK,1)
	proc.wait_simdt(bt)
	v:set_thrustergrouplevel(THGROUP.ATT_BACK,0)
	end
end

function lin_forward(v,t)
local ht = v:get_thrusterhandle(14)
local t1 = oapi.get_simtime()
while oapi.get_simtime()<t1+t do
v:set_thrusterlevel(ht,1)
proc.skip()
end
v:set_thrusterlevel(ht,0)
end

function burntime_att (v,dv)
local m0 = v:get_mass()
local isp = 5000 ---5500
local F = 2*9355.44 ---5000
local dt = isp*m0/F*(1-math.exp(-dv/isp))
return dt
end

function burntime_oms (v,dv)
local m0 = v:get_mass()
local isp = 3100
local F = 53400
local dt = isp*m0/F*(1-math.exp(-dv/isp))
return dt
end

function burntime_att_for (v,dv)
local m0 = v:get_mass()
local isp = 5000
local F = 9355.44
local dt = isp*m0/F*(1-math.exp(-dv/isp))
return dt
end

function rv_from_r0v0(R0, V0, t)
local r0 = vec.length(R0)
local v0 = vec.length(V0)
local vr0 = vec.dotp(R0,V0)/r0
local alpha = 2/r0-v0*v0/mu
local x = kepler_U(t,r0,vr0,alpha)
local f,g = f_and_g(x,t,r0,alpha)
local R = vec.add(vec.mul(f,R0),vec.mul(g,V0))
local r = vec.length(R)
local fdot,gdot = fDot_and_gDot(x,r,r0,alpha)
local V = vec.add(vec.mul(fdot,R0),vec.mul(gdot,V0))
return R,V
end

function kepler_U(dt,ro,vro,a)
local error2 = 1e-8
local nMax = 1000
local x = math.sqrt(mu)*math.abs(a)*dt
local n = 0
local ratio = 1
local C = 0
local S = 0
local F = 0
local dFdx = 0
while math.abs(ratio)>error2 and n<=nMax do
n = n+1
C = stumpC(a*x*x)
S = stumpS(a*x*x)
F = ro*vro/math.sqrt(mu)*x*x*C+(1-a*ro)*power(x,3)*S+ro*x-math.sqrt(mu)*dt
dFdx = ro*vro/math.sqrt(mu)*x*(1-a*x*x*S)+(1-a*ro)*x*x*C+ro
ratio = F/dFdx
x = x-ratio
end
return x
end

function stumpS(z)
local s = 0
if z>0 then
s = (math.sqrt(z)-math.sin(math.sqrt(z)))/power(math.sqrt(z),3)
elseif z<0 then
s = (math.sinh(math.sqrt(-z))-math.sqrt(-z))/power(math.sqrt(-z),3)
else
s = 1/6
end
return s
end

function stumpC(z)
local c = 0
if z>0 then
c = (1-math.cos(math.sqrt(z)))/z
elseif z<0 then
c = (math.cosh(math.sqrt(-z))-1)/(-z)
else
c = 0.5
end
return c
end

function f_and_g(x,t,ro,a)
local z = a*x*x
local f = 1-x*x/ro*stumpC(z)
local g = t-1/math.sqrt(mu)*power(x,3)*stumpS(z)
return f,g
end

function fDot_and_gDot(x,r,ro,a)
local z = a*x*x
local fdot = math.sqrt(mu)/r/ro*(z*stumpS(z)-1)*x
local gdot = 1-x*x/r*stumpC(z)
return fdot,gdot
end

function lambert (R1, R2, t)
r1 = vec.length(R1)
r2 = vec.length(R2)
c12 = vec.crossp(R1,R2)
local theta = math.acos(vec.dotp(R1,R2)/r1/r2)
if c12.z <= 0 then
	theta = 2*PI-theta
end
A = math.sin(theta)*math.sqrt(r1*r2/(1-math.cos(theta)))
z = -100
while F(z,t) < 0 do
	z = z+0.1
end
local tol = 1e-8
local nmax = 1000
local ratio = 1
local n = 0
while math.abs(ratio) > tol and n<=nmax do
	n = n+1
	ratio = F(z,t)/dFdz(z)
	z = z-ratio
	--proc.skip()
end
local f = 1- yy(z)/r1
local g = A*math.sqrt(yy(z)/mu)
local gdot = 1- yy(z)/r2
local V1 = vec.mul(1/g,vec.sub(R2,vec.mul(f,R1)))
local V2 = vec.mul(1/g,vec.sub(vec.mul(gdot,R2),R1))
return V1
end

function yy(z)
local dum = r1+r2+A*(z*S(z)-1)/math.sqrt(C(z))
return dum
end

function F(z,t)
local dum = power((yy(z)/C(z)),1.5)*S(z)+A*math.sqrt(yy(z))-math.sqrt(mu)*t
return dum
end

function dFdz(z)
local dum = 0
if z==0
then
dum = math.sqrt(2)/40*power(yy(0),1.5)+A/8*(math.sqrt(yy(0))+A*math.sqrt(1/2/yy(0)))
else
dum = power(yy(z)/C(z),1.5)*(1/2/z*(C(z)-3*S(z)/2/C(z))+3*power(S(z),2)/4/C(z))+A/8*(3*S(z)/C(z)*math.sqrt(yy(z))+A*math.sqrt(C(z)/yy(z)))
end
return dum
end

function C(z)
local dum = stumpC(z)
return dum
end

function S(z)
local dum = stumpS(z)
return dum
end

function matrixmult(a,b)
	local c = {	m11=a.m11*b.m11+a.m12*b.m21+a.m13*b.m31, m12=a.m11*b.m12+a.m12*b.m22+a.m13*b.m32, m13=a.m11*b.m13+a.m12*b.m23+a.m13*b.m33,
				m21=a.m21*b.m11+a.m22*b.m21+a.m23*b.m31, m22=a.m21*b.m12+a.m22*b.m22+a.m23*b.m32, m23=a.m21*b.m13+a.m22*b.m23+a.m23*b.m33,
				m31=a.m31*b.m11+a.m32*b.m21+a.m33*b.m31, m32=a.m31*b.m12+a.m32*b.m22+a.m33*b.m32, m33=a.m31*b.m13+a.m32*b.m23+a.m33*b.m33}
	return c
end

function transpose_matrix(a)
	local b = {m11=a.m11,m12=a.m21,m13=a.m31,m21=a.m12,m22=a.m22,m23=a.m32,m31=a.m13,m32=a.m23,m33=a.m33}
	return b
end

function sv_from_coe (v)
	local e = ecc(v)
	local a = SMA(v)
	local r_p = (1-e)*a
	local h = math.sqrt(r_p*mu*(1+e))
	local RA = LAN(v)
	local incl = inc(v)
	local TA = tra(v)
	local w = LPe(v) - LAN(v)
	local rp_factor = h*h/(mu*(1+e*math.cos(TA)))
	local rp = {}; rp.x = rp_factor*math.cos(TA); rp.y = rp_factor*math.sin(TA); rp.z = 0
	local vp_factor = mu/h
	local vp = {}; vp.x = -vp_factor*math.sin(TA); vp.y = vp_factor*(e+math.cos(TA)); vp.z = 0
	local R3_W = {m11=math.cos(RA),m12=math.sin(RA),m13=0,m21=-math.sin(RA),m22=math.cos(RA),m23=0,m31=0,m32=0,m33=1}
	local R1_i = {m11=1,m12=0,m13=0,m21=0,m22=math.cos(incl),m23=math.sin(incl),m31=0,m32=-math.sin(incl),m33=math.cos(incl)}
	local R3_w = {m11=math.cos(w),m12=math.sin(w),m13=0,m21=-math.sin(w),m22=math.cos(w),m23=0,m31=0,m32=0,m33=1}
	local R2 = matrixmult(R3_w,R1_i)
	local Q_Xp = matrixmult(R2,R3_W)
	local Q_pX = transpose_matrix(Q_Xp)
	local r = mat.mul(Q_pX,rp)
	local v = mat.mul(Q_pX,vp)
	return r,v
end

function LPe (v)
	el = v:get_elements()
	return el.omegab
end

function tra (v)
	el,prm = v:get_elementsex()
	return prm.TrA
end

function inc (v)
	el = v:get_elements()
	return el.i
end

function LAN (v)
	el = v:get_elements()
	return el.theta
end

function apt (v)
	el,prm = vif:get_elementsex()
	return prm.ApT
end

function pet (v)
	el,prm = vif:get_elementsex()
	return prm.PeT
end

function SMA (v)
	el = v:get_elements()
	return el.a
end

function ecc (v)
	el = v:get_elements()
	return el.e
end

function rva_relative_r(rA,vA,rB,vB)
	local hA = vec.crossp(rA,vA)
	local i = vec.mul(rA,1/vec.length(rA))
	local k = vec.mul(hA,1/vec.length(hA))
	local j = vec.crossp(k,i)
	local QXx = {m11=i.x, m12=i.y, m13=i.z, m21=j.x, m22=j.y, m23=j.z, m31=k.x, m32=k.y, m33=k.z}
	local r_rel = vec.sub(rB,rA)
	local r_rel_x = mat.mul(QXx,r_rel)
	return r_rel_x
end

function elevat(r_i,v_i,r_f,v_f)
	r_relativex=rva_relative_r(r_i,v_i,r_f,v_f)
	local elevation = math.atan2(r_relativex.x,r_relativex.y)
	return elevation
end

function elev_now(v)
local r_i,v_i=sv_from_coe(v)
local r_f,v_f=sv_from_coe(target)
local elev=elevat(r_i,v_i,r_f,v_f)
term.out(elev*DEG)
end

function find_elev(v,t,bt,elev)
local t1 = oapi.get_simtime()
local t0 = t1
local t2 = t+bt
dt=10
local r_ia,v_ia = sv_from_coe(v)
local r_fa,v_fa = sv_from_coe(target)
while dt>1 do
IAR,IAV = rv_from_r0v0(r_ia,v_ia,(t1+t2)/2-t0)
IPR,IPV = rv_from_r0v0(r_fa,v_fa,(t1+t2)/2-t0)
elev_neu = elevat(IAR,IAV,IPR,IPV)
if elev_neu>elev then
t2=t1+(t2-t1)/2
elseif elev_neu<elev then
t1=t1+(t2-t1)/2
end
dt=t2-t1
end
return (t1+t2)/2
end

function attoff(v)
v:set_thrustergrouplevel (THGROUP.ATT_PITCHDOWN, 0)
v:set_thrustergrouplevel (THGROUP.ATT_PITCHUP, 0)
v:set_thrustergrouplevel (THGROUP.ATT_YAWLEFT, 0)
v:set_thrustergrouplevel (THGROUP.ATT_YAWRIGHT , 0)
v:set_thrustergrouplevel (THGROUP.ATT_BANKLEFT, 0)
v:set_thrustergrouplevel (THGROUP.ATT_BANKRIGHT, 0)
v:set_thrustergrouplevel (THGROUP.ATT_RIGHT, 0)
v:set_thrustergrouplevel (THGROUP.ATT_LEFT, 0)
v:set_thrustergrouplevel (THGROUP.ATT_UP, 0)
v:set_thrustergrouplevel (THGROUP.ATT_DOWN, 0)
v:set_thrustergrouplevel (THGROUP.ATT_FORWARD, 0)
v:set_thrustergrouplevel (THGROUP.ATT_BACK , 0)
end

function power (b,e)
	local ergebnis = 0
	if (b<0 and e~=math.ceil(e)) then
	ergebnis = -math.pow(-b,e)
	else
	ergebnis = math.pow(b,e)
	end
return ergebnis
end